umbrello: UMLEnum Class Reference

umbrello 25.04.0 Umbrello UML Modeller is a Unified Modelling Language (UML) diagram program based on KDE Technology

Signals | Public Member Functions | Protected Member Functions | Private Member Functions | List of all members
UMLEnum Class Reference

Non-graphical Information for an Enum. More...

`#include <enum.h>`

Inheritance diagram for UMLEnum:

## Signals
void | enumLiteralAdded (UMLClassifierListItem *)
void | enumLiteralRemoved (UMLClassifierListItem *)
Signals inherited from UMLClassifier
void | operationAdded (UMLClassifierListItem *)
void | operationRemoved (UMLClassifierListItem *)
void | templateAdded (UMLClassifierListItem *)
void | templateRemoved (UMLClassifierListItem *)
void | attributeAdded (UMLClassifierListItem *)
void | attributeRemoved (UMLClassifierListItem *)
Signals inherited from UMLCanvasObject
void | sigAssociationEndAdded (UMLAssociation *assoc)
void | sigAssociationEndRemoved (UMLAssociation *assoc)
Signals inherited from UMLObject
void | modified ()

## Public Member Functions
| UMLEnum (const QString &name=QString(), Uml::ID::Type id=Uml::ID::None)
virtual | ~UMLEnum ()
bool | operator== (const UMLEnum &rhs) const
virtual void | copyInto (UMLObject *lhs) const
virtual UMLObject * | clone () const
UMLObject * | createEnumLiteral (const QString &name=QString())
UMLObject * | addEnumLiteral (const QString &name, Uml::ID::Type id=Uml::ID::None, const QString &value=QString())
bool | addEnumLiteral (UMLEnumLiteral *literal, IDChangeLog *Log=nullptr)
bool | addEnumLiteral (UMLEnumLiteral *literal, int position)
int | removeEnumLiteral (UMLEnumLiteral *literal)
int | enumLiterals () const
void | signalEnumLiteralRemoved (UMLClassifierListItem *elit)
virtual void | saveToXMI (QXmlStreamWriter &writer)
virtual UMLClassifierListItem * | makeChildObject (const QString &xmiTag)
Public Member Functions inherited from UMLClassifier
| UMLClassifier (const QString &name=QString(), Uml::ID::Type id=Uml::ID::None)
virtual | ~UMLClassifier ()
virtual void | setNameCmd (const QString &strName)
virtual UMLAttribute * | createAttribute (const QString &name=QString(), UMLObject *type=nullptr, Uml::Visibility::Enum vis=Uml::Visibility::Private, const QString &init=QString())
UMLAttribute * | addAttribute (const QString &name, Uml::ID::Type id=Uml::ID::None)
UMLAttribute * | addAttribute (const QString &name, UMLObject *type, Uml::Visibility::Enum scope)
bool | addAttribute (UMLAttribute *att, IDChangeLog *log=nullptr, int position=-1)
int | removeAttribute (UMLAttribute *att)
UMLAttributeList | getAttributeList () const
UMLAttributeList | getAttributeList (Uml::Visibility::Enum scope) const
UMLAttributeList | getAttributeListStatic (Uml::Visibility::Enum scope) const
UMLOperation * | createOperation (const QString &name=QString(), bool *isExistingOp=nullptr, Model_Utils::NameAndType_List *params=nullptr)
bool | addOperation (UMLOperation *op, int position=-1)
bool | addOperation (UMLOperation *op, IDChangeLog *log)
UMLOperation * | checkOperationSignature (const QString &name, UMLAttributeList opParams, UMLOperation *exemptOp=nullptr) const
int | removeOperation (UMLOperation *op)
int | operations () const
UMLOperationList | getOpList (bool includeInherited=false, UMLClassifierSet *alreadyTraversed=nullptr) const
UMLObject * | createTemplate (const QString &name=QString())
UMLTemplate * | addTemplate (const QString &name, Uml::ID::Type id=Uml::ID::None)
bool | addTemplate (UMLTemplate *newTemplate, IDChangeLog *log=nullptr)
bool | addTemplate (UMLTemplate *templt, int position)
int | removeTemplate (UMLTemplate *umltemplate)
UMLTemplate * | findTemplate (const QString &name) const
int | templates () const
UMLTemplateList | getTemplateList () const
int | takeItem (UMLClassifierListItem *item)
virtual UMLClassifierListItemList | getFilteredList (UMLObject::ObjectType ot) const
virtual bool | resolveRef ()
UMLOperationList | findOperations (const QString &n) const
virtual UMLObject * | findChildObjectById (Uml::ID::Type id, bool considerAncestors=false) const
UMLOperation * | findOperation (const QString &name, Model_Utils::NameAndType_List params) const
UMLClassifierList | findSuperClassConcepts (ClassifierType type=ALL) const
UMLClassifierList | findSubClassConcepts (ClassifierType type=ALL) const
virtual bool | acceptAssociationType (Uml::AssociationType::Enum type) const
void | setBaseType (UMLObject::ObjectType ot)
bool | isInterface () const
bool | hasAbstractOps () const
bool | hasAssociations () const
bool | hasAttributes () const
bool | hasStaticAttributes () const
bool | hasMethods () const
bool | hasAccessorMethods () const
bool | hasOperationMethods () const
bool | hasVectorFields () const
void | removeObject (UMLObject *pObject)
virtual UMLAssociationList | getUniAssociationToBeImplemented () const
Public Member Functions inherited from UMLPackage
| UMLPackage (const QString &name=QString(), Uml::ID::Type id=Uml::ID::None)
virtual | ~UMLPackage ()
bool | addObject (UMLObject *pObject, bool interactOnConflict=true)
virtual void | removeAllObjects ()
UMLObjectList | containedObjects (bool includeInactive=false) const
void | addAssocToConcepts (UMLAssociation *assoc)
void | removeAssocFromConcepts (UMLAssociation *assoc)
UMLObject * | findObject (const QString &name) const
UMLObject * | findObjectById (Uml::ID::Type id) const
void | appendPackages (UMLPackageList &packages, bool includeNested=true) const
void | appendClassifiers (UMLClassifierList &classifiers, bool includeNested=true) const
void | appendClassesAndInterfaces (UMLClassifierList &classifiers, bool includeNested=true) const
void | appendEntities (UMLEntityList &entities, bool includeNested=true) const
Public Member Functions inherited from UMLCanvasObject
| UMLCanvasObject (const QString &name=QString(), Uml::ID::Type id=Uml::ID::None)
virtual | ~UMLCanvasObject ()
bool | operator== (const UMLCanvasObject &rhs) const
bool | addAssociationEnd (UMLAssociation *assoc)
bool | hasAssociation (UMLAssociation *assoc) const
int | removeAssociationEnd (UMLAssociation *assoc)
void | removeAllAssociationEnds ()
int | associations () const
UMLAssociationList | getAssociations () const
UMLAssociationList | getSpecificAssocs (Uml::AssociationType::Enum assocType) const
UMLClassifierList | getSuperClasses (bool withRealizations=true) const
UMLClassifierList | getSubClasses () const
virtual UMLAssociationList | getRealizations () const
UMLAssociationList | getAggregations () const
UMLAssociationList | getCompositions () const
UMLAssociationList | getRelationships () const
virtual UMLObject * | findChildObject (const QString &n, UMLObject::ObjectType t=UMLObject::ot_UMLObject) const
virtual QString | uniqChildName (const UMLObject::ObjectType type, const QString &prefix=QString()) const
virtual void | removeAllChildObjects ()
UMLObjectList & | subordinates () const
Public Member Functions inherited from UMLObject
| UMLObject (const UMLObject &other)
| UMLObject (UMLObject *parent, const QString &name, Uml::ID::Type id=Uml::ID::None)
| UMLObject (UMLObject *parent)
| UMLObject (const QString &name=QString(), Uml::ID::Type id=Uml::ID::None)
virtual | ~UMLObject ()
bool | operator== (const UMLObject &rhs) const
ObjectType | baseType () const
QLatin1String | baseTypeStr () const
virtual void | setID (Uml::ID::Type NewID)
virtual Uml::ID::Type | id () const
QString | doc () const
bool | hasDoc () const
void | setDoc (const QString &d)
void | setVisibility (Uml::Visibility::Enum visibility)
void | setVisibilityCmd (Uml::Visibility::Enum visibility)
Uml::Visibility::Enum | visibility () const
void | setStereotype (const QString &_name)
void | setStereotypeCmd (const QString &_name)
QString | stereotype (bool includeAdornments=false) const
void | setUMLStereotype (UMLStereotype *stereo)
UMLStereotype * | umlStereotype () const
QStringList & | tags ()
QString | package (const QString &separator=QString(), bool includeRoot=false) const
UMLPackageList | packages (bool includeRoot=false) const
bool | setUMLPackage (UMLPackage *pPkg)
UMLPackage * | umlPackage () const
void | setUMLParent (UMLObject *parent)
UMLObject * | umlParent () const
virtual void | setName (const QString &strName)
QString | name () const
virtual QString | fullyQualifiedName (const QString &separator=QString(), bool includeRoot=false) const
void | setAbstract (bool bAbstract)
bool | isAbstract () const
virtual bool | showPropertiesDialog (QWidget *parent=nullptr)
virtual bool | loadFromXMI (QDomElement &element)
bool | loadStereotype (QDomElement &element)
void | setStatic (bool bStatic)
bool | isStatic () const
void | setSecondaryId (const QString &id)
QString | secondaryId () const
void | setSecondaryFallback (const QString &id)
QString | secondaryFallback () const
void | save1 (QXmlStreamWriter &writer, const QString &type, const QString &tag=QString())
bool | isUMLActor () const
bool | isUMLArtifact () const
bool | isUMLAssociation () const
bool | isUMLAttribute () const
bool | isUMLCategory () const
bool | isUMLCheckConstraint () const
bool | isUMLClassifier () const
bool | isUMLComponent () const
bool | isUMLDatatype () const
bool | isUMLEntity () const
bool | isUMLEntityAttribute () const
bool | isUMLEntityConstraint () const
bool | isUMLEnum () const
bool | isUMLEnumLiteral () const
bool | isUMLFolder () const
bool | isUMLForeignKeyConstraint () const
bool | isUMLInstance () const
bool | isUMLInstanceAttribute () const
bool | isUMLNode () const
bool | isUMLObject () const
bool | isUMLOperation () const
bool | isUMLPackage () const
bool | isUMLPort () const
bool | isUMLRole () const
bool | isUMLStereotype () const
bool | isUMLTemplate () const
bool | isUMLUniqueConstraint () const
bool | isUMLUseCase () const
UMLActor * | asUMLActor ()
UMLArtifact * | asUMLArtifact ()
UMLAssociation * | asUMLAssociation ()
UMLAttribute * | asUMLAttribute ()
UMLCanvasObject * | asUMLCanvasObject ()
UMLCategory * | asUMLCategory ()
UMLCheckConstraint * | asUMLCheckConstraint ()
UMLClassifier * | asUMLClassifier ()
UMLClassifierListItem * | asUMLClassifierListItem ()
UMLClassifierSet * | asUMLClassifierSet ()
UMLComponent * | asUMLComponent ()
UMLDatatype * | asUMLDatatype ()
UMLEntity * | asUMLEntity ()
UMLEntityAttribute * | asUMLEntityAttribute ()
UMLEntityConstraint * | asUMLEntityConstraint ()
UMLEnum * | asUMLEnum ()
UMLEnumLiteral * | asUMLEnumLiteral ()
UMLFolder * | asUMLFolder ()
UMLForeignKeyConstraint * | asUMLForeignKeyConstraint ()
UMLInstance * | asUMLInstance ()
UMLInstanceAttribute * | asUMLInstanceAttribute ()
UMLNode * | asUMLNode ()
UMLObject * | asUMLObject ()
UMLOperation * | asUMLOperation ()
UMLPackage * | asUMLPackage ()
UMLPort * | asUMLPort ()
UMLRole * | asUMLRole ()
UMLStereotype * | asUMLStereotype ()
UMLTemplate * | asUMLTemplate ()
UMLUniqueConstraint * | asUMLUniqueConstraint ()
UMLUseCase * | asUMLUseCase ()
const UMLActor * | asUMLActor () const
const UMLArtifact * | asUMLArtifact () const
const UMLAssociation * | asUMLAssociation () const
const UMLAttribute * | asUMLAttribute () const
const UMLCanvasObject * | asUMLCanvasObject () const
const UMLCategory * | asUMLCategory () const
const UMLCheckConstraint * | asUMLCheckConstraint () const
const UMLClassifier * | asUMLClassifier () const
const UMLClassifierListItem * | asUMLClassifierListItem () const
const UMLClassifierSet * | asUMLClassifierSet () const
const UMLComponent * | asUMLComponent () const
const UMLDatatype * | asUMLDatatype () const
const UMLEntity * | asUMLEntity () const
const UMLEntityAttribute * | asUMLEntityAttribute () const
const UMLEntityConstraint * | asUMLEntityConstraint () const
const UMLEnum * | asUMLEnum () const
const UMLEnumLiteral * | asUMLEnumLiteral () const
const UMLFolder * | asUMLFolder () const
const UMLForeignKeyConstraint * | asUMLForeignKeyConstraint () const
const UMLInstance * | asUMLInstance () const
const UMLInstanceAttribute * | asUMLInstanceAttribute () const
const UMLNode * | asUMLNode () const
const UMLObject * | asUMLObject () const
const UMLOperation * | asUMLOperation () const
const UMLPackage * | asUMLPackage () const
const UMLPort * | asUMLPort () const
const UMLRole * | asUMLRole () const
const UMLStereotype * | asUMLStereotype () const
const UMLTemplate * | asUMLTemplate () const
const UMLUniqueConstraint * | asUMLUniqueConstraint () const
const UMLUseCase * | asUMLUseCase () const

## Protected Member Functions
bool | load1 (QDomElement &element)
Protected Member Functions inherited from UMLObject
void | init ()
void | maybeSignalObjectCreated ()
void | save1end (QXmlStreamWriter &writer)

## Private Member Functions
void | init ()

## Additional Inherited Members
Public Types inherited from UMLClassifier
enum | ClassifierType { ALL = 0 , CLASS , INTERFACE , DATATYPE }
Public Types inherited from UMLObject
enum | ObjectType { ot_Unknown = -1 , ot_UMLObject = 100 , ot_Actor , ot_UseCase , ot_Package , ot_Interface , ot_Datatype , ot_Enum , ot_Class , ot_Instance , ot_Association , ot_Attribute , ot_Operation , ot_EnumLiteral , ot_Template , ot_Component , ot_Artifact , ot_Node , ot_Stereotype , ot_Role , ot_Entity , ot_EntityAttribute , ot_Folder , ot_EntityConstraint , ot_UniqueConstraint , ot_ForeignKeyConstraint , ot_CheckConstraint , ot_Category , ot_Port , ot_InstanceAttribute , ot_SubSystem }
Public Slots inherited from UMLObject
void | emitModified ()
Static Public Member Functions inherited from UMLObject
static QString | toString (ObjectType ot)
static QString | toI18nString (ObjectType t)
static Icon_Utils::IconType | toIcon (ObjectType t)
Protected Attributes inherited from UMLPackage
UMLObjectList | m_objects
Protected Attributes inherited from UMLObject
Uml::ID::Type | m_nId
| object's id
QString | m_Doc
| object's documentation
QPointer< UMLStereotype > | m_pStereotype
| stereotype of the object if applicable
QString | m_name
| objects name
ObjectType | m_BaseType
| objects type
Uml::Visibility::Enum | m_visibility
| objects visibility
bool | m_bAbstract
| state of whether the object is abstract or not
bool | m_bStatic
| flag for instance scope
bool | m_bCreationWasSignalled
| auxiliary to maybeSignalObjectCreated()
QPointer< UMLObject > | m_pSecondary
QString | m_SecondaryId
QString | m_SecondaryFallback
QStringList | m_TaggedValues
UMLObjectPrivate * | m_d
| private data

## Detailed Description

Non-graphical Information for an Enum.

This class contains the non-graphical information required for a UML Enum. This class inherits from UMLClassifier which contains most of the information.

Author
  Jonathan Riddell Bugs and comments to umbre.nosp@m.llo-.nosp@m.devel.nosp@m.@kde.nosp@m..org or https://bugs.kde.org

## Constructor & Destructor Documentation

## ◆ UMLEnum()

UMLEnum::UMLEnum | ( | const QString & | name = QString(),
|  | Uml::ID::Type | id = Uml::ID::None )
| explicit

Sets up an enum.

Parameters

  name | The name of the Enum.
  id | The unique id of the Enum.

## ◆ ~UMLEnum()

UMLEnum::~UMLEnum | ( |  | ) |
| virtual

Standard destructor.

## Member Function Documentation

## ◆ addEnumLiteral() [1/3]

UMLObject * UMLEnum::addEnumLiteral | ( | const QString & | name,
|  | Uml::ID::Type | id = Uml::ID::None,
|  | const QString & | value = QString() )

Adds an enumliteral to the enum.

Parameters

  name | The name of the enumliteral.
  id | The id of the enumliteral (optional.) If omitted a new ID is assigned internally.
  value | Optional numeric representation of the enumliteral.

Returns
  Pointer to the UMLEnumliteral created.

## ◆ addEnumLiteral() [2/3]

bool UMLEnum::addEnumLiteral | ( | UMLEnumLiteral * | literal,
|  | IDChangeLog * | Log = nullptr )

Adds an already created enumliteral. The enumliteral object must not belong to any other classifier.

Parameters

  literal | Pointer to the UMLEnumLiteral.
  Log | Pointer to the IDChangeLog.

Returns
  True if the enumliteral was successfully added.

## ◆ addEnumLiteral() [3/3]

bool UMLEnum::addEnumLiteral | ( | UMLEnumLiteral * | literal,
|  | int | position )

Adds an enumliteral to the enum, at the given position. If position is negative or too large, the enumliteral is added to the end of the list. TODO: give default value -1 to position (append) - now it conflicts with the method above..

Parameters

  literal | Pointer to the UMLEnumLiteral.
  position | Position index for the insertion.

Returns
  True if the enumliteral was successfully added.

## ◆ clone()

UMLObject * UMLEnum::clone | ( |  | ) | const
| virtual

Make a clone of this object.

Reimplemented from UMLClassifier.

## ◆ copyInto()

void UMLEnum::copyInto | ( | UMLObject * | lhs | ) | const
| virtual

Copy the internal presentation of this object into the new object.

Reimplemented from UMLClassifier.

## ◆ createEnumLiteral()

UMLObject * UMLEnum::createEnumLiteral | ( | const QString & | name = QString() | ) |

Creates a literal for the enum.

Returns
  The UMLEnum created

## ◆ enumLiteralAdded

void UMLEnum::enumLiteralAdded | ( | UMLClassifierListItem * |  | ) |
| signal

## ◆ enumLiteralRemoved

void UMLEnum::enumLiteralRemoved | ( | UMLClassifierListItem * |  | ) |
| signal

## ◆ enumLiterals()

int UMLEnum::enumLiterals | ( |  | ) | const

Returns the number of enumliterals for the class.

Returns
  The number of enumliterals for the class.

## ◆ init()

void UMLEnum::init | ( |  | ) |
| private

Initializes key variables of the class.

## ◆ load1()

bool UMLEnum::load1 | ( | QDomElement & | element | ) |
| protectedvirtual

Loads the <UML:Enum> element including its enumliterals.

Reimplemented from UMLClassifier.

## ◆ makeChildObject()

UMLClassifierListItem * UMLEnum::makeChildObject | ( | const QString & | xmiTag | ) |
| virtual

Create a new ClassifierListObject (enumLiteral) according to the given XMI tag. Returns NULL if the string given does not contain one of the tags <UML:EnumLiteral> Used by the clipboard for paste operation. Reimplemented from UMLClassifier for UMLEnum

Reimplemented from UMLClassifier.

## ◆ operator==()

bool UMLEnum::operator== | ( | const UMLEnum & | rhs | ) | const

Overloaded '==' operator.

## ◆ removeEnumLiteral()

int UMLEnum::removeEnumLiteral | ( | UMLEnumLiteral * | literal | ) |

Removes an enumliteral from the class.

Parameters

  literal | The enumliteral to remove.

Returns
  Count of the remaining enumliterals after removal. Returns -1 if the given enumliteral was not found.

## ◆ saveToXMI()

void UMLEnum::saveToXMI | ( | QXmlStreamWriter & | writer | ) |
| virtual

Creates the <UML:Enum> element including its enumliterals.

Reimplemented from UMLClassifier.

## ◆ signalEnumLiteralRemoved()

void UMLEnum::signalEnumLiteralRemoved | ( | UMLClassifierListItem * | elit | ) |

Emit the enumLiteralRemoved signal.

The documentation for this class was generated from the following files:

- umbrello/umlmodel/enum.h
- umbrello/umlmodel/enum.cpp